//**************************************************************************
//  Copyright (c) 2011 Igor Timurov, t051200@yandex.ru
//  All Rights Reserved.
//**************************************************************************

#ifndef __FBASE__HED__
#define __FBASE__HED__

#include <io.h>
#include <stdio.h>
#include <string>
#include <iostream>
#include <fstream>
#include <memory>
#include <fcntl.h>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <windows.h>

#define FDF_EXPORT extern "C" __declspec(dllexport)

#pragma warning(disable: 4996)

using namespace std;

typedef signed __int8       Byte;
typedef unsigned __int8     UByte;
typedef signed __int16      Short;
typedef unsigned __int16    UShort;
typedef signed __int32      Long;
typedef unsigned __int32    ULong;
typedef unsigned __int16    WChar;
typedef void*               Handle;

//    .
#define OUT

//    .
#define IN

//     __forceinline
#define inl __forceinline

//   .
#define __CONCAT(var_1,var_2)			var_1 ## var_2
#define FDF_CONCAT(var_1,var_2)			__CONCAT(var_1,var_2)
#define FDF_CONCAT3(var_1,var_2,var_3)	FDF_CONCAT(var_1,FDF_CONCAT(var_2, var_3))

//   
#define FDF_WIDEN(var)          FDF_CONCAT(L, var)

//  .
#define FDF_STRING(var)          __FDF_STRING(var)
#define __FDF_STRING(var)        #var

//   .
#define FDF_WSTRING(var)        FDF_WIDEN(FDF_STRING(var))

//    
#define __WFILE__     FDF_WIDEN(__FILE__)
#define __WDATE__     FDF_WIDEN(__DATE__)
#define __WTIME__     FDF_WIDEN(__TIME__)
#define __WLINE__     FDF_WIDEN(FDF_STRING(__LINE__))

//        (Debug).
#ifdef _DEBUG
#define DEBUG_CODE(code)        {code ;}
#else
#define DEBUG_CODE(code)        {;}
#endif

#define FDF_PI   (3.14159265358979323846) //
#define FDF_2PI  (6.28318530717958647692) //2*
#define FDF_PI2  (1.57079632679489661923) ///2
#define FDF_PI3  (1.04719755119659774615) ///3
#define FDF_E    (2.71828182845904523536) //e

inl float ModRad(float rad)
{
    rad += (float)FDF_PI;
    if (rad < 0)
        return (float)FDF_PI - ::fmod(-rad, (float)FDF_2PI);
    else
        return ::fmod(rad, (float)FDF_2PI) - (float)FDF_PI;
}

inl float Deg2Rad(float deg)
{
    float rad = deg * (float)FDF_2PI / 360.0f;
    return ModRad(rad);
}

#endif //__FBASE__HED__