//**************************************************************************
//  Copyright (c) 2011 Igor Timurov, t051200@yandex.ru
//  All Rights Reserved.
//**************************************************************************

#ifndef __FMATRIX__HED__
#define __FMATRIX__HED__

#include "FBase.h"

template<class T>
class FMatrix
{
public:
    FMatrix()
    {
        Clear();
    }
    FMatrix(const FMatrix& other)
    {
        Clear();
        Copy(other);
    }

    FMatrix& operator = (const FMatrix& other) 
    { 
        Copy(other);
        return *this; 
    }
    ~FMatrix()
    {
        Realese();
    }
    void Copy(const FMatrix& other)
    {
        if (this == &other)
            return;
        Realese();
        Create(other.width, other.height);
        for(ULong j = 0; j < height; ++j)
        {
            for(ULong i = 0; i < width; ++i)
            {
                matrix[j][i] = other.matrix[j][i];
            }
        }
    }
    inl T** Src()
    {
        return matrix;
    }
    inl ULong Width() const
    {
        return width;
    }
    inl ULong Height() const
    {
        return height;
    }
    inl bool Check(const ULong& x, const ULong& y) const
    {
        return 0 <= x && x < width && 0 <= y && y < height;
    }
    void Create(ULong _width, ULong _height) 
    {
        width = _width;
        height = _height;
        matrix = new T*[height];
        for(ULong i = 0; i < height; ++i)
        {
            matrix[i] = new T[width];
        }
    }
    void Realese() 
    {
        if (matrix != 0)
        {
            for(ULong i = 0; i < height; ++i)
            {
                delete[] matrix[i];
            }
            delete[] matrix;
        }
        Clear();
    }
protected:
private:
    void Clear() 
    {
        memset(this, 0, sizeof(FMatrix<T>));
    }
private:
    ULong width;
    ULong height;
    T** matrix;
};

#endif //__FMATRIX__HED__