//**************************************************************************
//  Copyright (c) 2011 Igor Timurov, t051200@yandex.ru
//  All Rights Reserved.
//**************************************************************************

#ifndef __FSCANNER_IMAGE__HED__
#define __FSCANNER_IMAGE__HED__

#include "FMatrix.h"
#include "FColor.h"
#include "FAlgorithm.h"
#include "FVector3.h"

class FScannerImage
{
public:
    FMatrix<float> gray;
    FVector3 direct;

    void Make(UByte* src, ULong bpp, ULong width, ULong height, const FVector3& _direct)
    {
        direct = _direct;
        gray.Create(width, height);
        ULong bytepp = bpp / 8;
        ULong bytepl = width * bytepp;
        bytepl += (4 - bytepl % 4) % 4;
        for(ULong y = 0; y < height; ++y)
        {
            for(ULong x = 0; x < width; ++x)
            {
                UByte* c = src + (height - y - 1) * bytepl + x * bytepp;
                if (bytepp == 3)
                    gray.Src()[y][x] = (float)ToGray(c) / 255.0f;
                else if (bytepp == 6)
                    gray.Src()[y][x] = (float)UShortToGray((UShort*)c) / 65535.0f;
            }
        }
    }

private:
};

#endif //__FSCANNER_IMAGE__HED__