//**************************************************************************
//  Copyright (c) 2011 Igor Timurov, t051200@yandex.ru
//  All Rights Reserved.
//**************************************************************************

#include "FScanner.h"

int __stdcall DllMain(HANDLE hModule, DWORD ul_reason_for_call, void* lpReserved)
{
    switch(ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
            //::SetPriorityClass( GetCurrentProcess(), REALTIME_PRIORITY_CLASS );
            //::SetThreadPriority( GetCurrentThread(), THREAD_PRIORITY_HIGHEST );
        break;
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
        break;
    }
    return 1;
}

FDF_EXPORT 
void Hello()
{
    //MessageBoxW( NULL, L"Hello", L"Hello", MB_YESNO | MB_ICONEXCLAMATION);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //OutputDebugStringW(L" ");
    //FMatrix3 a(1,2,3,4,5,11,7,3,9);
    //FMatrix3 b(a);
    //FMatrix3 c;
    //c.Identity();
    //b *= c;
    //a.Invertible();
    //b *= a;

    //float angleX = FDF_PI2/9;
    //float angleY = FDF_PI2/9;

    //FVector3 direct(0, 0, 1);
    //FMatrix3 m;
    //m.Rotation(angleX, 0, 0);
    //m.Transform(direct);

    //FVector3 L1(0, 0.422618181f, 0.9063078f);
    //FVector3 L2(0, -0.422618181f, 0.9063078f);
    //FVector3 L3(-0.422618181f, 0, 0.9063078f);
    //FMatrix3 m1;
    //m1.SetRow(L1, L2, L3);
    //m1.Invertible();
    //m1.Transpose();

    //FVector3 c(cos(Deg2Rad(30)), cos(Deg2Rad(20)), cos(Deg2Rad(25)));

    //m1.Transform(c);
    //c.Normalize();
}

FDF_EXPORT 
void* CreateSC(ULong width, ULong height)
{
    FScanner* scanner = new FScanner(width, height);
    return scanner;
}

FDF_EXPORT
void ReleaseSC(FScanner* scanner)
{
    if (scanner == 0)
        return;
    delete scanner;
    scanner = 0;
}

FDF_EXPORT
ULong AddImage(FScanner* scanner, UByte* image, ULong bpp, const FVector3& direct)
{
    if (scanner == 0)
        return -1;
    FScannerImage* simage = new FScannerImage;
    simage->Make(image, bpp, scanner->Width(), scanner->Height(), direct);
    return scanner->AddImage(simage);
}

FDF_EXPORT
void GrayToBmp(FScanner* scanner, ULong img, UByte* image)
{
    if (scanner == 0)
        return;
    scanner->GrayToBmp(img, image);
}

FDF_EXPORT
void MakeNormal(FScanner* scanner, ULong img1, ULong img2, ULong img3)
{
    if (scanner == 0)
        return;
    scanner->MakeNormal(img1, img2, img3);
    scanner->MakeDelta();
}

FDF_EXPORT
void CorrectNormal(FScanner* scanner, int &curv, int maxv)
{
    for(; curv < maxv; ++curv)
    {
        scanner->MakeOneIteration();
    }
}

FDF_EXPORT
void MakeHeight(FScanner* scanner)
{
    if (scanner == 0)
        return;
    scanner->MakeHeight();
}

FDF_EXPORT
void NormalToBmp(FScanner* scanner, UByte* image)
{
    if (scanner == 0)
        return;
    scanner->NormalToBmp(image);
}

FDF_EXPORT
void NormalToDxyBmp(FScanner* scanner, UByte* image)
{
    if (scanner == 0)
        return;
    scanner->NormalToDxyBmp(image);
}

FDF_EXPORT
void NormalToDzBmp(FScanner* scanner, UByte* image)
{
    if (scanner == 0)
        return;
    scanner->NormalToDzBmp(image);
}

FDF_EXPORT
void ErrorToBmp(FScanner* scanner, UByte* image)
{
    if (scanner == 0)
        return;
    scanner->ErrorToBmp(image);
}
FDF_EXPORT
void HeightToBmp(FScanner* scanner, UByte* image)
{
    if (scanner == 0)
        return;
    scanner->HeightToBmp(image);
}

FDF_EXPORT
void HeightToRaw(FScanner* scanner, UShort* raw, float& scale)
{
    if (scanner == 0)
        return;
    scanner->HeightToRaw(raw, scale);
}

FDF_EXPORT
void HeightToFloat(FScanner* scanner, float* raw, float& scale)
{
    if (scanner == 0)
        return;
    scanner->HeightToFloat(raw, scale);
}

FDF_EXPORT
void DirectByAngle(float angleX, float angleY, FVector3& direct)
{
    direct = FVector3(0, 0, 1);
    FMatrix3 m;
    m.Rotation(Deg2Rad(angleX), Deg2Rad(angleY), 0);
    m.Transform(direct);
}

FDF_EXPORT
void DirectByVector(float vectorX, float vectorY, float magnitude, FVector3& direct)
{
    direct = FVector3(-vectorX, -vectorY, magnitude);
    direct.Normalize();
}

FDF_EXPORT
void DirectByDirect(FVector3& direct)
{
    direct.Normalize();
}

FDF_EXPORT
void Sub(UByte* img1, UByte* img2, ULong width, ULong height)
{
    ULong bytesPerLine = BytesPerLine(width, 24);
    int t;
    for(ULong y = 0; y < height; ++y)
    {
        for(ULong x = 0; x < width; ++x)
        {
            UByte* c1 = img1 + y * bytesPerLine + x * 3;
            UByte* c2 = img2 + y * bytesPerLine + x * 3;
            c1[0] = (t = (int)c1[0] - c2[0]) < 0 ? 0 : t;
            c1[1] = (t = (int)c1[1] - c2[1]) < 0 ? 0 : t;
            c1[2] = (t = (int)c1[2] - c2[2]) < 0 ? 0 : t;
        }
    }
}


/*
int qwemain()
{
    vector<FMapInfo> info;
    //info.push_back(FMapInfo(L"Data\\shift\\02.bmp", FFVector2(-1.0f, 0.0f))); // right
    //info.push_back(FMapInfo(L"Data\\shift\\03.bmp", FFVector2( 1.0f, 0.0f))); // left
    //info.push_back(FMapInfo(L"Data\\shift\\04.bmp", FFVector2( 0.0f,-1.0f))); // down
    //info.push_back(FMapInfo(L"Data\\shift\\05.bmp", FFVector2( 0.0f, 1.0f))); // up

    //info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map2/c/c0001.bmp", FFVector2( 00.0f,-25.0f)));
    //info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map2/c/c0002.bmp", FFVector2( 00.0f, 25.0f)));
    //info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map2/c/c0003.bmp", FFVector2(-25.0f, 00.0f)));
    //info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map2/c/c0004.bmp", FFVector2( 25.0f, 00.0f)));

    info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map4/g/c0005.bmp", FFVector2( 00.0f,-10.0f)));
    info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map4/g/c0006.bmp", FFVector2( 00.0f, 10.0f)));
    info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map4/g/c0007.bmp", FFVector2(-10.0f, 00.0f)));
    info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map4/g/c0008.bmp", FFVector2( 10.0f, 00.0f)));

    //info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map2/g/c0009.bmp", FFVector2(-20.0f,-20.0f)));
    //info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map2/g/c0010.bmp", FFVector2( 20.0f,-20.0f)));
    //info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map2/g/c0011.bmp", FFVector2( 20.0f, 20.0f)));
    //info.push_back(FMapInfo(L"C:/Users/Frozen/Documents/3dsmax/renderoutput/map2/g/c0012.bmp", FFVector2(-20.0f, 20.0f)));

    FScanner scaner(info);
    scaner.Calculate();
    scaner.SaveGray(L"00-gray.bmp", 0);
    scaner.SaveGray(L"01-gray.bmp", 1);
    scaner.SaveDeltaX(L"02-deltaX.bmp");
    scaner.SaveDeltaY(L"03-deltaY.bmp");
    scaner.SaveHeiht(L"04-height.bmp");
    scaner.SaveRaw(L"height.raw");
    
    FGL fgl;
    //fgl.Run(scaner.heightMap);

    return 0;
}*/