﻿//**************************************************************************
//  Copyright (c) 2011 Igor Timurov, t051200@yandex.ru
//  All Rights Reserved.
//**************************************************************************

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;

namespace SurfaceScanner
{
    public partial class ProgressForm : Form
    {
        public delegate void Worker(ref int minv, ref int maxv, ref int curv);
        delegate void Fun();
        int minv = 0;
        int maxv = 10;
        int curv = 0;
        Thread thread;
        Worker worker;

        public ProgressForm(Worker worker)
        {
            InitializeComponent();
            thread = new Thread(Work);
            this.worker = worker;
        }

        public void Work(Object worker)
        {
            ((Worker)worker)(ref minv, ref maxv, ref curv);
            this.Invoke(new Fun(Close));
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            progress_bar.Minimum = minv;
            progress_bar.Maximum = maxv;
            progress_bar.Value = curv;
            label.Text = string.Format("{0}/{1} done.", curv - minv, maxv - minv);
        }

        private void ProgressForm_Load(object sender, EventArgs e)
        {
        }

        private void ProgressForm_Shown(object sender, EventArgs e)
        {
            thread.Start(worker);
        }
    }
}
