﻿//**************************************************************************
//  Copyright (c) 2011 Igor Timurov, t051200@yandex.ru
//  All Rights Reserved.
//**************************************************************************

using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Imaging;
using FreeImageAPI;

namespace SurfaceScanner
{
    public class ScannerImage
    {
        public UInt32 Id = 0;
        public string Path;
        public Bitmap Bmp;
        public ScannerLib.Vector3 direct = new ScannerLib.Vector3();

        FIBITMAP fbmp;
        FIBITMAP fbmp24;

        public void Load(string path)
        {
            fbmp = FreeImage.LoadEx(path);
            fbmp24 = FreeImage.ConvertTo24Bits(fbmp);
            Bmp = FreeImage.GetBitmap(fbmp24);

            this.Path = path;
        }

        public void Unload()
        {
            FreeImage.Unload(fbmp);
            FreeImage.Unload(fbmp24);
        }

        public void ToScanner(IntPtr SC, Rectangle rect)
        {
            FIBITMAP image = FreeImage.Copy(fbmp, rect.Left, rect.Top, rect.Right, rect.Bottom);
            uint width = FreeImage.GetWidth(image);
            uint height = FreeImage.GetHeight(image);
            IntPtr scan = FreeImage.GetBits(image);
            uint bpp = FreeImage.GetBPP(image);
            uint line = FreeImage.GetLine(image);

            Id = ScannerLib.AddImage(SC, scan, bpp, ref direct);
            FreeImage.Unload(image);
        }
    }
}
