﻿//**************************************************************************
//  Copyright (c) 2011 Igor Timurov, t051200@yandex.ru
//  All Rights Reserved.
//**************************************************************************

using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;

namespace SurfaceScanner
{
    public static class ScannerLib
    {
        public const string SLIB_DLL = @"ScannerLib.dll";

        [DllImport(SLIB_DLL, EntryPoint = "Hello")]
        public static extern void Hello();

        [DllImport(SLIB_DLL, EntryPoint = "CreateSC")]
        public static extern IntPtr CreateSC(UInt32 Width, UInt32 Height);

        [DllImport(SLIB_DLL, EntryPoint = "ReleaseSC")]
        public static extern void ReleaseSC(IntPtr SC);

        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        public struct Vector3
        {
            public float X;
            public float Y;
            public float Z;
        }

        //[DllImport(SLIB_DLL, EntryPoint = "AddImage")]
        //public static extern UInt32 AddImage(IntPtr SC, IntPtr image, UInt32 stride, ref Vector3 direct);

        [DllImport(SLIB_DLL, EntryPoint = "AddImage")]
        public static extern UInt32 AddImage(IntPtr SC, IntPtr scan, UInt32 bpp, ref Vector3 direct);

        [DllImport(SLIB_DLL, EntryPoint = "GrayToBmp")]
        public static extern void GrayToBmp(IntPtr SC, UInt32 img, IntPtr image);

        [DllImport(SLIB_DLL, EntryPoint = "MakeNormal")]
        public static extern void MakeNormal(IntPtr SC, UInt32 img1, UInt32 img2, UInt32 img3);

        [DllImport(SLIB_DLL, EntryPoint = "CorrectNormal")]
        public static extern void CorrectNormal(IntPtr SC, ref int curv, int maxv);
        
        [DllImport(SLIB_DLL, EntryPoint = "NormalToBmp")]
        public static extern void NormalToBmp(IntPtr SC, IntPtr image);

        [DllImport(SLIB_DLL, EntryPoint = "NormalToDxyBmp")]
        public static extern void NormalToDxyBmp(IntPtr SC, IntPtr image);
        
        [DllImport(SLIB_DLL, EntryPoint = "NormalToDzBmp")]
        public static extern void NormalToDzBmp(IntPtr SC, IntPtr image);

        [DllImport(SLIB_DLL, EntryPoint = "ErrorToBmp")]
        public static extern void ErrorToBmp(IntPtr SC, IntPtr image);

        [DllImport(SLIB_DLL, EntryPoint = "MakeHeight")]
        public static extern void MakeHeight(IntPtr SC);

        [DllImport(SLIB_DLL, EntryPoint = "HeightToBmp")]
        public static extern void HeightToBmp(IntPtr SC, IntPtr image);

        [DllImport(SLIB_DLL, EntryPoint = "HeightToRaw")]
        public static extern void HeightToRaw(IntPtr SC, byte[] raw, ref float scale);

        [DllImport(SLIB_DLL, EntryPoint = "HeightToFloat")]
        public static extern void HeightToFloat(IntPtr SC, float[] raw, ref float scale);

        [DllImport(SLIB_DLL, EntryPoint = "DirectByAngle")]
        public static extern void DirectByAngle(float angleX, float angleY, ref Vector3 direct);

        [DllImport(SLIB_DLL, EntryPoint = "DirectByVector")]
        public static extern void DirectByVector(float vectorX, float vectorY, float magnitude, ref Vector3 vector3);

        [DllImport(SLIB_DLL, EntryPoint = "DirectByDirect")]
        public static extern void DirectByDirect(ref Vector3 vector3);

        [DllImport(SLIB_DLL, EntryPoint = "Sub")]
        public static extern void Sub(IntPtr img1, IntPtr img2, UInt32 width, UInt32 height);



        /*
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        private struct ImageParam
        {
            [MarshalAs(UnmanagedType.LPStr)]
            public String m_ExecutPath;
            [MarshalAs(UnmanagedType.LPStr)]
            public String m_Directory;
            public Int32 m_Time;
            public Int32 m_Memmory;
            public Int32 m_OutCrash;
            public Int32 m_OutTime;
            public Int32 m_OutMemmory;
            public IntPtr m_OutDesc;
            public IntPtr m_OutInfo;
        }

        static public void ExecuteSecurity(Task testerParameters)
        {
            try
            {
                // создать структуру в .NET:
                ExecuteParameters aExecuteParameters = new ExecuteParameters();
                aExecuteParameters.m_Directory = testerParameters.m_Directory;
                aExecuteParameters.m_ExecutPath = testerParameters.m_ExecutPath;
                aExecuteParameters.m_Time = testerParameters.m_Task.time_limit;
                aExecuteParameters.m_Memmory = testerParameters.m_Task.memory_limit + Config.m_ConstMemory;

                // получить реальный её размер в байтах
                int structSizeInBytes = Marshal.SizeOf(typeof(ExecuteParameters));
                // выделить в куче буфер для нашей структуры
                IntPtr aExecuteParametersPtr = Marshal.AllocHGlobal(structSizeInBytes);
                // скопировать .NET структуру в только что выделенный unmanaged кусок памяти
                Marshal.StructureToPtr(aExecuteParameters, aExecuteParametersPtr, false);
                // вызвать нашу функцию в DLL, передав указатель на структуру
                Execute(aExecuteParametersPtr);

                // считать результаты
                aExecuteParameters = (ExecuteParameters)Marshal.PtrToStructure(aExecuteParametersPtr, typeof(ExecuteParameters));
                testerParameters.m_OutCrash = (TesterResult)aExecuteParameters.m_OutCrash;
                testerParameters.m_OutTime = aExecuteParameters.m_OutTime;
                testerParameters.m_OutMemmory = aExecuteParameters.m_OutMemmory - Config.m_ConstMemory;
                if (testerParameters.m_OutMemmory < 0)
                {
                    testerParameters.m_OutMemmory = 0;
                }
                testerParameters.m_OutDesc = Marshal.PtrToStringAnsi(aExecuteParameters.m_OutDesc);
                testerParameters.m_OutInfo = Marshal.PtrToStringAnsi(aExecuteParameters.m_OutInfo);

                // освободить кусок памяти в куче
                Marshal.FreeHGlobal(aExecuteParametersPtr);
            }
            catch (System.Exception e)
            {
                WriteLog("Ошибка: " + e.Message);
            }

        }
         * */
    }
}
