﻿//**************************************************************************
//  Copyright (c) 2011 Igor Timurov, t051200@yandex.ru
//  All Rights Reserved.
//**************************************************************************

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace SurfaceScanner
{
    public partial class ViewForm : Form
    {
        private SaveFileDialog saveFile;

        public ViewForm(Bitmap bmp)
        {
            InitializeComponent();
            picture_box.Image = bmp;

            this.saveFile = new SaveFileDialog();
            this.saveFile.Filter = "Bitmap (*.bmp)|*.bmp";
            this.saveFile.InitialDirectory = Path.GetDirectoryName(Application.ExecutablePath);
            this.saveFile.FilterIndex = 1;
            this.saveFile.RestoreDirectory = true;
        }

        private void fileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveFile.ShowDialog(this) == DialogResult.OK)
            {
                try
                {
                    picture_box.Image.Save(saveFile.FileName);
                }
                catch (Exception exc)
                {
                    MessageBox.Show(exc.Message);
                }
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
